/*
 * Created on 2004/06/01
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package casablanca;

import org.boxed_economy.besp.model.fmfw.behavior.AbstractBehavior;

import org.boxed_economy.besp.model.fmfw.behavior.CompositeState;
import org.boxed_economy.besp.model.fmfw.behavior.State;
import org.boxed_economy.besp.model.fmfw.behavior.StateMachineFactory;
import org.boxed_economy.besp.model.fmfw.behavior.Transition;

import org.boxed_economy.besp.model.fmfw.ChannelEvent;
import org.boxed_economy.besp.model.fmfw.behavior.Action;

import org.boxed_economy.besp.model.fmfw.TimeEvent;

/**
* AbstractAnsweringBehavior
*/
public abstract class AbstractAnsweringBehavior extends AbstractBehavior {

	/**
	* This method automatically generated from Boxed Economy Behavior Editor.
	* Don't modify this method.
	*/
	protected void initializeStateMachine() {
		//factory
		StateMachineFactory factory = this.getStateMachine();

		//states
		State initialState = factory.createInitialState();
		CompositeState answeringAction =
			factory.createCompositeState("AnsweringAction");
		CompositeState answerAgainAction =
			factory.createCompositeState("AnswerAgainAction");
		CompositeState waitingAction =
			factory.createCompositeState("WaitingAction");
		CompositeState lastAnswerAction =
			factory.createCompositeState("LastAnswerAction");

		//actions
		Action lastAnswerAction1 = new Action() {
			public void doAction() {
				lastAnswerAction1();
			}
			public String toString() {
				return "lastAnswerAction1";
			}
		};
		Action answerAgainAction1 = new Action() {
			public void doAction() {
				answerAgainAction1();
			}
			public String toString() {
				return "answerAgainAction1";
			}
		};
		Action answeringAction1 = new Action() {
			public void doAction() {
				answeringAction1();
			}
			public String toString() {
				return "answeringAction1";
			}
		};

		//guard-conditions

		//transitions
		Transition transitionLastAnswerActionToWaitingAction =
			factory.createTransition();
		Transition transitionWaitingActionToAnsweringAction =
			factory.createTransition();
		Transition transitionAnsweringActionToAnswerAgainAction =
			factory.createTransition();
		Transition transitionAnswerAgainActionToLastAnswerAction =
			factory.createTransition();
		Transition transitionInitialStateToWaitingAction =
			factory.createTransition();

		//states setting

		//structure of states
		this.setInitialState(initialState);
		this.addState(answeringAction);
		this.addState(answerAgainAction);
		this.addState(waitingAction);
		this.addState(lastAnswerAction);

		//transitions setting
		transitionWaitingActionToAnsweringAction.setEvent(ChannelEvent.class);
		transitionWaitingActionToAnsweringAction.addAction(answeringAction1);
		transitionAnsweringActionToAnswerAgainAction.setEvent(
			ChannelEvent.class);
		transitionAnsweringActionToAnswerAgainAction.addAction(
			answerAgainAction1);
		transitionAnswerAgainActionToLastAnswerAction.setEvent(
			ChannelEvent.class);
		transitionAnswerAgainActionToLastAnswerAction.addAction(
			lastAnswerAction1);

		//connection of transitions
		transitionLastAnswerActionToWaitingAction.setSourceState(
			lastAnswerAction);
		transitionLastAnswerActionToWaitingAction.setTargetState(waitingAction);
		transitionWaitingActionToAnsweringAction.setSourceState(waitingAction);
		transitionWaitingActionToAnsweringAction.setTargetState(
			answeringAction);
		transitionAnsweringActionToAnswerAgainAction.setSourceState(
			answeringAction);
		transitionAnsweringActionToAnswerAgainAction.setTargetState(
			answerAgainAction);
		transitionAnswerAgainActionToLastAnswerAction.setSourceState(
			answerAgainAction);
		transitionAnswerAgainActionToLastAnswerAction.setTargetState(
			lastAnswerAction);
		transitionInitialStateToWaitingAction.setSourceState(initialState);
		transitionInitialStateToWaitingAction.setTargetState(waitingAction);

	}

	/**
	*lastAnswerAction1
	*/
	protected abstract void lastAnswerAction1();
	/**
	*answerAgainAction1
	*/
	protected abstract void answerAgainAction1();
	/**
	*answeringAction1
	*/
	protected abstract void answeringAction1();
}
