/*
 * Created on 2004/06/01
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package casablanca;

import org.boxed_economy.besp.model.fmfw.behavior.AbstractBehavior;

import org.boxed_economy.besp.model.fmfw.TimeEvent;
import org.boxed_economy.besp.model.fmfw.behavior.Action;
import org.boxed_economy.besp.model.fmfw.behavior.CompositeState;
import org.boxed_economy.besp.model.fmfw.behavior.State;
import org.boxed_economy.besp.model.fmfw.behavior.StateMachineFactory;
import org.boxed_economy.besp.model.fmfw.behavior.Transition;

import org.boxed_economy.besp.model.fmfw.ChannelEvent;

/**
* AbstractAskingQuestionBehavior
*/
public abstract class AbstractAskingQuestionBehavior extends AbstractBehavior {

	/**
	* This method automatically generated from Boxed Economy Behavior Editor.
	* Don't modify this method.
	*/
	protected void initializeStateMachine() {
		//factory
		StateMachineFactory factory = this.getStateMachine();

		//states
		State initialState = factory.createInitialState();
		CompositeState normal = factory.createCompositeState("Normal");
		CompositeState gettingAngry =
			factory.createCompositeState("GettingAngry");
		CompositeState askQuestion =
			factory.createCompositeState("AskQuestion");
		CompositeState askQuestionAgin =
			factory.createCompositeState("AskQuestionAgin");
		CompositeState getsAngryAction =
			factory.createCompositeState("GetsAngryAction");

		//actions
		Action gettingAngryAction = new Action() {
			public void doAction() {
				gettingAngryAction();
			}
			public String toString() {
				return "gettingAngryAction";
			}
		};
		Action askingQuestionAction = new Action() {
			public void doAction() {
				askingQuestionAction();
			}
			public String toString() {
				return "askingQuestionAction";
			}
		};
		Action askQuestionAgainAction = new Action() {
			public void doAction() {
				askQuestionAgainAction();
			}
			public String toString() {
				return "askQuestionAgainAction";
			}
		};
		Action getsAngryAction1 = new Action() {
			public void doAction() {
				getsAngryAction1();
			}
			public String toString() {
				return "getsAngryAction1";
			}
		};

		//guard-conditions

		//transitions
		Transition transitionGettingAngryToAskQuestion =
			factory.createTransition();
		Transition transitionGetsAngryActionToNormal =
			factory.createTransition();
		Transition transitionNormalToGettingAngry = factory.createTransition();
		Transition transitionAskQuestionAginToGetsAngryAction =
			factory.createTransition();
		Transition transitionInitialStateToNormal = factory.createTransition();
		Transition transitionAskQuestionToAskQuestionAgin =
			factory.createTransition();

		//states setting

		//structure of states
		this.setInitialState(initialState);
		this.addState(normal);
		this.addState(gettingAngry);
		this.addState(askQuestion);
		this.addState(askQuestionAgin);
		this.addState(getsAngryAction);

		//transitions setting
		transitionGettingAngryToAskQuestion.setEvent(TimeEvent.class);
		transitionGettingAngryToAskQuestion.addAction(askingQuestionAction);
		transitionNormalToGettingAngry.setEvent(TimeEvent.class);
		transitionNormalToGettingAngry.addAction(gettingAngryAction);
		transitionAskQuestionAginToGetsAngryAction.setEvent(ChannelEvent.class);
		transitionAskQuestionAginToGetsAngryAction.addAction(getsAngryAction1);
		transitionAskQuestionToAskQuestionAgin.setEvent(ChannelEvent.class);
		transitionAskQuestionToAskQuestionAgin.addAction(
			askQuestionAgainAction);

		//connection of transitions
		transitionGettingAngryToAskQuestion.setSourceState(gettingAngry);
		transitionGettingAngryToAskQuestion.setTargetState(askQuestion);
		transitionGetsAngryActionToNormal.setSourceState(getsAngryAction);
		transitionGetsAngryActionToNormal.setTargetState(normal);
		transitionNormalToGettingAngry.setSourceState(normal);
		transitionNormalToGettingAngry.setTargetState(gettingAngry);
		transitionAskQuestionAginToGetsAngryAction.setSourceState(
			askQuestionAgin);
		transitionAskQuestionAginToGetsAngryAction.setTargetState(
			getsAngryAction);
		transitionInitialStateToNormal.setSourceState(initialState);
		transitionInitialStateToNormal.setTargetState(normal);
		transitionAskQuestionToAskQuestionAgin.setSourceState(askQuestion);
		transitionAskQuestionToAskQuestionAgin.setTargetState(askQuestionAgin);

	}

	/**
	*gettingAngryAction
	*/
	protected abstract void gettingAngryAction();
	/**
	*askingQuestionAction
	*/
	protected abstract void askingQuestionAction();
	/**
	*askQuestionAgainAction
	*/
	protected abstract void askQuestionAgainAction();
	/**
	*getsAngryAction1
	*/
	protected abstract void getsAngryAction1();
}
